<?php

namespace App\Console;

use App\Console\Commands\AddBimToConvertQueue;
use App\Console\Commands\SyncBimConvertStatus;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * Define the application's command schedule.
     */
    protected function schedule(Schedule $schedule): void
    {
        // $schedule->command('inspire')->hourly();

        $schedule->command("tenant:run lpc:add-bim-to-convert-queue")->everyTwoMinutes()->runInBackground();

        $schedule->command("tenant:run lpc:sync-bim-convert-status")->everyTwoMinutes()->runInBackground();
    }

    /**
     * Register the commands for the application.
     */
    protected function commands(): void
    {
        $this->load(__DIR__.'/Commands');

        require base_path('routes/console.php');
    }
}
