<?php

namespace App\Models;

use Encore\Admin\Traits\DefaultDatetimeFormat;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Stancl\Tenancy\Contracts;
use Stancl\Tenancy\Database\Concerns;
class GlobalUser extends Model implements Contracts\Domain
{
    use Concerns\CentralConnection;
    use HasFactory,SoftDeletes;
    use DefaultDatetimeFormat;

    protected $guarded = [
        'id'
    ];
    protected $fillable = [
        'username',
        'tenant_id'
    ];
    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];


    protected $table = 'global_users';

    public function tenant()
    {
        return $this->belongsTo(config('tenancy.tenant_model'));
    }
}
