<?php

namespace Database\Seeders;

use App\Models\Company;
use App\Models\Enums\ObjectApprovalStatus;
use App\Models\GlobalUser;
use App\Models\Role;
use Illuminate\Database\Seeder;
use App\Models\User;
use Illuminate\Support\Facades\Hash;

class SuperAdminSeeder extends Seeder
{
    /**
     * Run the database seeds.
     */
    public function run(): void
    {
        Company::create([
            'name' => tenant()->company_name,
            'email' => tenant()->email,
            'review_status' => ObjectApprovalStatus::APPROVED->value,
            'exp_date' => date('Y-m-d', strtotime(tenant()->expired_at)),
        ]);

        $user = User::create([
            'name' => tenant()->id,
            'email' => tenant()->email,
            'password' => Hash::make(tenant()->id),
            'username' => tenant()->id,
            'company_id' => 1,
            'role_id' => config("auth.super_admin_role_id")
        ]);
        $role = Role::query()->findOrFail($user['role_id']);
        $user->syncRoles($role);
    }
}
